/* IBM Confidential
* OCO Source Materials
* 5724-U98, 5655-V48, 5724-U50, 5655-V46
* © Copyright IBM Corp. 2013
* The source code for this program is not published or other -
* wise divested of its trade secrets, irrespective of what has
* been deposited with the U.S. Copyright Office.
*/
define(["dojo/_base/declare",
        "dojo/_base/lang",
    	"dojo/store/Memory",
    	"dijit/form/ComboBox",
        "dijit/_Widget",
        "dijit/_TemplatedMixin",
        "dijit/_WidgetsInTemplateMixin",
        "dojo/text!./templates/DsiWizardIntroPage.html",
        "dojo/i18n!./nls/widget_resources"],
        function(dDeclare,					// (dojo/_base/declare)
				 dLang,						// (dojo/_base/lang)
				 dMemory,                   // (dojo/store/Memory)
				 dComboBox,                 // (idx/form/ComboBox)
		         dWidget,					// (dijit/_Widget)
		         dTemplatedMixin,			// (dijit/_TemplatedMixin)
		         dWidgetsInTemplateMixin,	// (dijit/_WidgetsInTemplateMixin)
		         templateText,				// (dojo/text!./templates/DsiWizardFirstPage.html)
		         resources)
{
	
	
	//Constants
	
	/**
	 * @name wizard.DsiWizardFirstPage
	 * @class The LoginFrame provides the standard login screen.
	 * @augments dijit._Widget
	 * @augments dijit._TemplatedMixin
	 * 
	 */
return dDeclare("wizard.DsiWizardIntroPage", [dWidget,dTemplatedMixin,dWidgetsInTemplateMixin],
		  /**@lends dsiwidget.wizard.DsiWizardFirstPage#*/		
{
	baseClass: "dsiWizardIntroPage",
	templateString: templateText,

	cannotGoBack: true,
	cannotGoNext: false,
	
		
	startup: function(){
		this.populateWizardMessage();
		this.inherited(arguments);
		
	},		

	
	getDescription: function() {
		var descriptionMessage = "";
		require(["dojo/dom"], function(dom){
			dom.byId("pageDescrDiv").style.height="5em";
			dom.byId("pageDescrDiv").style.visibility="visible";
    	});
		
		var	fieldsReq = "<div>" + resources['ocmWelcomeGeneral1'] + "</div>";
		if (inBootStrapMode){
			descriptionMessage = "<b>" + resources['ocmWelcome'] + "</b><br/>" + fieldsReq;
		}else{
			descriptionMessage = "<b>" + resources['wp1Description'] + "</b><br/>" + fieldsReq;
		}
		return descriptionMessage;
	},
	
	populateWizardMessage: function(){
		require(["dojo/dom"], function(dom){
			dom.byId("ocmWelcomeGeneral2").innerHTML = resources['ocmWelcomeGeneral2'];
			dom.byId("wizPage1Info").innerHTML = resources['wizPage1Info'];
			dom.byId("wizRequiredInfo").innerHTML = "<UL> <li>"+resources['wizRequiredBullet1']+"</li><li>"+resources['wizRequiredBullet2']+"</li><li>"+resources['wizRequiredBullet3']+"</li></UL>"
			dom.byId("wizPage2Info").innerHTML = resources['wizPage2Info'];
			dom.byId("wizWarning").innerHTML = "<BR/><span class='oneuiMsgInfo16' /><b><span style='padding-left:20px'>" +resources['wizWarning'] +"</span></b>";
    	});
		
	},
	
	pageInit: function(){		
	
	},	

	
	pageLoad: function(){
		
	},
	
	isReady: function(){		
		return true;
	},				

		
	_updateWizardButtons: function() {
		var wizard = this.getParent().getParent().getParent(); //->StackContainer->ContentPane(center)->BorderContainer(wizard)
		wizard._checkButtons();
	}
  
});
});