<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:optim="http://www.ibm.com/optim/audit/v11.3.0.0"
	xmlns:optimreport="http://www.ibm.com/optim/report/v11.3.0.0"
	xmlns:optimcommon="http://www.ibm.com/optim/common/v11.3.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
	
	<xsl:import href="CommonTemplates.xsl"/>
	
	<xsl:output method="html" indent="yes" version="4.0"
		doctype-public="-//W3C//DTD HTML 4.01//EN" doctype-system="http://www.w3.org/TR/html4/strict.dtd" />
				
	<!-- BEGIN Impact Analysis Results -->
	<xsl:template match="optimreport:impactAnalysisResults">
		
		<!--Set up anchor-->
		<xsl:call-template name="anchorSetup">
			<xsl:with-param name="name">impactanalysis</xsl:with-param>
		</xsl:call-template>

		<!-- Process Details Title Bar -->
		<xsl:call-template name="titleBar">
			<xsl:with-param name="name">Impact Analysis</xsl:with-param>
			<xsl:with-param name="containerId">impact_container</xsl:with-param>
			<xsl:with-param name="containerClass">impact_container_class</xsl:with-param>
			<xsl:with-param name="anchor">impactanalysis</xsl:with-param>
			<xsl:with-param name="closeByDefault">true</xsl:with-param>
			<xsl:with-param name="isInnerReport">false</xsl:with-param>
		</xsl:call-template>

		<div id="impact_container" class="section_container impact_container_class" inAllAction="true" style="display:none">
			<table class="impact_analysis">	
				<tr>
					<th>
						<center><xsl:text>Name</xsl:text></center>
					</th>
					<td>
						<center><b><xsl:text>Status</xsl:text></b></center>
					</td>
					<td>
						<center><b><xsl:text>Storage Savings</xsl:text></b></center>
					</td>
					<td>
						<center><b><xsl:text>Type</xsl:text></b></center>
					</td>
				</tr>
				<xsl:for-each select="optimreport:impactAnalysis">
					<tr>
						<th>
							<xsl:call-template name="stringCheck">
								<xsl:with-param name="value" select="@name"/>
							</xsl:call-template>
						</th>
						<td>
							<xsl:call-template name="stringCheck">
								<xsl:with-param name="value" select="optimreport:status"/>
							</xsl:call-template>
						</td>
						<td class="rightAlignRow">
							<xsl:choose>
								<xsl:when test='not(number(@storageSavings) = number(@storageSavings))'>
									<xsl:call-template name='stringCheck'>
										<xsl:with-param name='value' select='@storageSavings'/>
									</xsl:call-template>
									<xsl:text>&#160;(B)</xsl:text>
								</xsl:when>
								<xsl:otherwise>
									<xsl:call-template name="numberFormat">
										<xsl:with-param name="number" select="@storageSavings"/>
										<xsl:with-param name="digitsAfterPoint">0</xsl:with-param>
									</xsl:call-template>
									<xsl:text>&#160;(B)</xsl:text>
								</xsl:otherwise>
							</xsl:choose>
						</td>
						<td>
							<xsl:call-template name="stringCheck">
								<xsl:with-param name="value" select="optimreport:type"/>
							</xsl:call-template>
						</td>
					</tr>
				</xsl:for-each>
			</table>	
		</div>
	</xsl:template>
	<!-- END Impact Analysis Results -->
	
</xsl:stylesheet>

