<?xml version="1.0" encoding="utf-8"?>

<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:optim="http://www.ibm.com/optim/audit/v11.3.0.0"
	xmlns:optimreport="http://www.ibm.com/optim/report/v11.3.0.0"
	xmlns:optimcommon="http://www.ibm.com/optim/common/v11.3.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">

	<xsl:output method="html" indent="yes" version="4.0"
		doctype-public="-//W3C//DTD HTML 4.01//EN" doctype-system="http://www.w3.org/TR/html4/strict.dtd" />

	<xsl:template name="JSFunctions">
		<head>
				<!-- Javascript functions to add utility to the report -->
				<script language="javascript">
					// show the next title when clicked on one title
					function ShowNextTitle(classname, rowClass, event){
						if(event.preventDefault) {
							event.preventDefault();
						}else {
							event.returnValue = false;
						}
						
						var thisElement = event.target || event.srcElement;
						
						while(thisElement){
							if(thisElement.tagName == 'TR'){
								break;
							}
							
							thisElement = thisElement.parentNode;
						}
						
						thisElement = thisElement.nextSibling;
						
						while(thisElement){
							if(thisElement.tagName == 'TR' &amp;&amp; thisElement.className==classname){
								break;
							}
							
							thisElement = thisElement.nextSibling;
						}
						
						if(thisElement){
							var elements = getElementsByClassName(document, rowClass);
							var element = elements[0];
							if(element &amp;&amp; element.style.display == 'none'){
								thisElement.style.display = 'none';
							}else{
								thisElement.style.display = "";
							}
						}
					}
					
					function preventEvent(event){
						if(event.preventDefault) {
							event.preventDefault();
						}
						else {
							event.returnValue = false;
						}
					}
					
					// set the theader and tbody length for insert entity table
					function setRowWidth(className){
						// get all class
						var classList = getElementsByClassName(document, className);
						for(var i = 0; i &lt; classList.length; i++){
							var tableWidth = classList[i].width;
							var rows = classList[i].getElementsByTagName("tr");
							for(var j = 0; j &lt; rows.length; j++){
								rows[j].style.width = tableWidth + "px";
							}
						}
					}
				
					// pop up window for long name
					function longNamePopup(){
						var nodes = getElementsByClassName(document, "infopop_warning_class");
						for(var i = 0, x; x = nodes[i]; i++){
							x.onmouseover = function(event){
								// get the node that triggers the event
								event = event || window.event;
								var thisElement = this;
								var rect = this.getBoundingClientRect();
								var description = this.getAttribute('description');
								
								var elements = getElementsByClassName(thisElement.parentNode, 'popBlock');
								if(elements.length != 0){
									for(var j = 0; j &lt; elements.length; j++){
										elements[j].style.left = this.getBoundingClientRect().left + "px";
										elements[j].style.top = (this.getBoundingClientRect().top +  (document.documentElement.scrollTop | window.pageYOffset)) - 70 + "px";
										elements[j].innerHTML = description;
										elements[j].style.display = "";
										//alert(document.documentElement.scrollTop + " " + window.pageYOffset);
									}
								}
								
								
							};
							
							x.onmouseout = function(event){
								// get the node that triggers the event
								event = event || window.event;
								var thisElement = this;
								
								var elements = getElementsByClassName(thisElement.parentNode, "popBlock");
								
								for(var j = 0; j &lt; elements.length; j++){
									elements[j].style.display = "none";
								}
							}
						}
						
						// clear
						nodes = null;
						thisElement = null;
					}
					
					function messageCatalogBoard(){
						var nodes = getElementsByAttribute(document, "hasmessageBoard");
						
						for(var i = 0; i &lt; nodes.length; i++){
							nodes[i].onmouseover = function(event){
								// get the node that triggers the event
								event = event || window.event;
								var thisElement = event.target || event.srcElement;
								thisElement = thisElement.parentNode;
								var description = thisElement.getAttribute('description');
								var userResponse = thisElement.getAttribute('userResponse');
								var systemResponse = thisElement.getAttribute('systemResponse');
								
								if(description.length + userResponse.length + systemResponse.length &gt; 0){
									//get position
									var rect = (thisElement.getElementsByTagName("th"))[0].getBoundingClientRect();
										
									// get the length of element
									var l = (thisElement.getElementsByTagName("th"))[0].offsetWidth || (thisElement.getElementsByTagName("th"))[0].clientWidth;
									var t = thisElement.offsetTop;
									l = rect.left + l + 10;
									t = rect.top + document.documentElement.scrollTop + thisElement.clientHeight;
									//alert( document.documentElement.scrollTop);
									var htmlString = "<div>Description: <br/>"+description+"</div>"+"<div>User Response: <br/>"+userResponse+"</div>"+"<div>System Response: <br/>"+systemResponse+"</div>";
									var elements = getElementsByClassName(thisElement.parentNode.parentNode.parentNode, 'messageContent');
									elements[0].innerHTML = htmlString;
									elements[0].parentNode.style.left = l + "px";
									elements[0].parentNode.style.top = t + "px";
									elements[0].parentNode.style.display = "";
								}
							};
							
							/*
							nodes[i].onmouseout = function(event){
								// get the node that triggers the event
								event = event || window.event;
								var thisElement = event.target || event.srcElement;
								
								thisElement = thisElement.parentNode;
								var elements = getElementsByClassName(thisElement.parentNode.parentNode.parentNode, "messageContent");
								
								for(var j = 0; j &lt; elements.length; j++){
									elements[j].parentNode.style.display = "none";
									elements[j].innerHTML = "";
								}
							}
							*/
							
						}
						
						// clear
						nodes = null;
						thisElement = null;
					}
					
					function getElementsByAttribute(node, attribute)
					{
					  var matchingElements = [];
					  var allElements = node.getElementsByTagName('*');
					  for (var i = 0, x; x=allElements[i]; i++)
					  {
					    if (x.getAttribute(attribute))
					    {
					      // Element exists with attribute. Add to array.
					      matchingElements.push(x);
					    }
					  }
					  return matchingElements;
					}

					// This function allows us to get elements by class name
					// Javascript has a function embedded to do this, BUT
					// it is not supported in IE, so we needed to write our own.
					function getElementsByClassName(node, classname) {
						var array = [];
						var regex = new RegExp('(^| )'+classname+'( |$)');
						var elements = node.getElementsByTagName("*");
						for(var i = 0, j = elements.length; i &lt; j; i++) {
					        if(regex.test(elements[i].className)) {
					        	array.push(elements[i]);
					    	}
					    }
					    return array;
					}
					
					// toggle by Id in the same report level
					function toggleById(id, event){
						if(event.preventDefault) {
							event.preventDefault();
						}
						else {
							event.returnValue = false;
						}
						
						var node = document.getElementById(id);
						if(node.style.display == "") {
							node.style.display = "none";
						}
						else {
							node.style.display = "";
						}
					}
					
					// This function is used to show/hide sections of the report
					// for toggle section while section and title block are in the same level
					// hash: anchor name
					// sectionClass: container class
					function toggle(hash, sectionClass, event){
						if(event.preventDefault) {
							event.preventDefault();
						}
						else {
							event.returnValue = false;
						}
						
						// get the node that triggers the event
						var thisElement = event.target || event.srcElement;
						
						// find the parent of node that contains "drop_down_hover" class name
						// or "report_version_block_title" class name only for directory block
						while(thisElement){
							var className = thisElement.className;
							if(className){
								if(!(className.indexOf("drop_down_hover") &lt; 0)){
									break;
								}
								
								if(className == "report_version_block_title"){
									break;
								}
							}
							thisElement = thisElement.parentNode;
							
							// enable Garbage collection
							className = null;
						}
						
						// search for the sibling node of node
						while(thisElement){
							var name = thisElement.className;
							if(name){
								if(name.indexOf(sectionClass) &lt; 0){
									thisElement = thisElement.nextSibling;
								}else{
									break;
								}
							}else{
								thisElement = thisElement.nextSibling;
							}
							
							// enable Garbage collection
							name = null;
						}
						
						// toggle found section
						if(thisElement){
							if(thisElement.style.display == "") {
								thisElement.style.display = "none";
							}
							else {
								thisElement.style.display = "";
							}
						}
						
						// enable Garbage collection
						thisElement = null;
						//event = null;
						return false;
					}
					
					// This function is used to show/hide multiple rows of a table
					//classname: class name of rows that need to be expanded/collapsed
					function toggleRows(classname, event){
						var node = event.target || event.srcElement;
						
						var childNodes = node.parentNode.childNodes;
						var found = false;
						
						// find the "table" tag name
						while(node){
							if(node.tagName){
								if(node.tagName == "TABLE"){
									break;
								}
							}
							
							node = node.parentNode;
						}
						
						if(node){
							var rows = getElementsByClassName(node, classname);
						
							if(event.preventDefault) {
								event.preventDefault();
							}
							else {
								event.returnValue = false;
							}
						
							for(var i = 0,x; x=rows[i]; i++){
								if(x.style.display == "") {
									x.style.display = "none";
								}
								else {
									x.style.display = "";
								}
							}
						}
					}

                    function scrollToLink(hash, container, event)
                    {
                        scrollTo(hash, container, event);
                    }

					// This function is a goto from content list, jumping to the section provided and expanding it.
					// hash: anchor name
					// container: the block jump to
					function scrollTo(hash, container, event, level, numberOfExtract)
					{
						level = typeof level !== 'undefined' ? level : 1;
						numberOfExtract = typeof numberOfExtract !== 'undefined' ? numberOfExtract : -1;
						if(event.preventDefault) {
							event.preventDefault();
						}
						else {
							event.returnValue = false;
						}
						
						// get the current node that triggers the event
						var thisElement = event.target || event.srcElement;
						
						//console.log("this element: " + thisElement);
						var elementText = thisElement.getAttribute("section");
						//console.log("element text: " + elementText);
						// calculate the index of same name anchors
						var steps = 0;
						
						if(level == 2){
							thisElement = thisElement.parentNode.parentNode;
						}else{
							thisElement = thisElement.parentNode.previousSibling;
						}
						
						var tempElement = thisElement;
						if(level == 2){
							elementText = thisElement.getAttribute("section");
							thisElement = thisElement.previousSibling;
						}
						
						var ExtractIndex = 0;
						while(thisElement){
							if(thisElement.nodeType == 1 &amp;&amp; thisElement.getAttribute("section") &amp;&amp; thisElement.getAttribute("section").indexOf(elementText) &gt;= 0){
								steps += 1;
							}
							thisElement = thisElement.previousSibling;
						}
						
						thisElement = event.target || event.srcElement;
						// go to the parent node which containes "report_content_block" class
						while(thisElement){
							var className = thisElement.className;
							if(className){
								if(!(className.indexOf("report_content_block") &lt; 0)){
									break;
								}
							}
							thisElement = thisElement.parentNode;
						}
						
						//console.log("this element: " + thisElement);
						//console.log("steps: " + steps);
						// search for the sibling node of "report_content_block" node to find the place jump to
						var containers = getElementsByClassName(document, hash+"_anchor");
						
						for(var i = 0; i &lt; containers.length; i++){
							if(steps &lt;= 0){
								thisElement = containers[i];
								break;
							}
							steps -= 1;
						}
						
						if(thisElement.className != "innerreport_anchor"){
						
							while(thisElement){
								if(thisElement.nodeType == 1 &amp;&amp; thisElement.className.indexOf("section_container") &gt;= 0){
									break;
								}else{
									thisElement = thisElement.nextSibling;
								}
							}// if found, jump to and expand it
						var blockElement = thisElement;
						if(thisElement){
							if(thisElement.style.display == "none") {
								thisElement.style.display = "";
							}
							//window.location.href = "#" + hash;
							var display = thisElement.style.display;
							//find the title bar of this container, and swap the arrow
							while(thisElement){
								if(thisElement.className){
									if(!(thisElement.className.indexOf("section_header") &lt; 0)){
										break;
									}else{
										thisElement = thisElement.previousSibling;
									}
								}else{
									thisElement = thisElement.previousSibling;
								}
							}
							
							//console.log("this element: " + thisElement);
							var arrow = getElementsByClassName(thisElement, "blockArrow");
							
							if(arrow){
								for(var i = 0, x; x=arrow[i]; i++){
									if(display==""){
										x.src = switchArrow("c");
									}else{
										x.src = switchArrow("e");
									}
								}
							}
						}
						}
						
						//console.log("this element: " + thisElement);
						
						thisElement.scrollIntoView(true);
						
						if(getElementsByClassName(blockElement, 'table_access_headers').length &gt; 0){
							resizeTables("table_access_headers");
						}
						if(getElementsByClassName(blockElement, 'statistic_headers').length &gt; 0){
						resizeTables("statistic_headers");
						}
						// clean
						thisElement = null;
						//console.log("============================================");
					}
					
					function showTableRowsNonRestore(hash, classname, event){
						if(event.preventDefault) {
							event.preventDefault();
						}else {
							event.returnValue = false;
						}
						var index = 0;
						var thisElement = event.target || event.srcElement;
						
						while(thisElement){
							if(thisElement.className &amp;&amp; !(thisElement.className.indexOf('section_container') &lt; 0)){
								break;
							}
							
							if(thisElement.tagName.indexOf('TR') &gt;= 0){
							var table = document.getElementById('overview_table');
								var pos = thisElement.rowIndex;
								for(var i = 0, row; row = table.rows[i]; i++){
									if(row.innerHTML.indexOf('Process status') &gt;= 0){
										index = row.rowIndex;
										break;
									}
								}
								index = pos - index;
								
								if(index &lt;= 0){
									index = 1;
								}
							}
							
							thisElement = thisElement.parentNode;
						}
						var oldElement = thisElement;
						thisElement = thisElement.nextSibling;
						
						if(thisElement){
							while(thisElement){
								if(thisElement.className &amp;&amp; !(thisElement.className.indexOf('summary_container_class') &lt; 0)){
									if(index == 1){
										break;
									}else{
										index--;
									}
								}else if(thisElement.className &amp;&amp; !(thisElement.className.indexOf('section_header') &lt; 0) &amp;&amp; thisElement.getAttribute('anchor-name').indexOf('procsum') &gt;= 0){
									if(index == 1){
										oldElement = thisElement;
									}
								}
								thisElement = thisElement.nextSibling;
							}
						}
						// have to check if the process message panel is open
						var test = thisElement.style.display;
						if(test != "")
						{
							var funcName = oldElement.onclick;
							if(document.createEvent){
								var evt = document.createEvent("MouseEvents");
								evt.initEvent("click", false, false);
								oldElement.dispatchEvent(evt);
							}else if(document.createEventObject){
								var evt = document.createEventObject("MouseEvents");
								//evt.initEvent("click", false, false);
								oldElement.fireEvent('onclick', evt);
							}
						}
					
						var rows = getElementsByClassName(thisElement, classname);

						for(var i = 0, x; x=rows[i]; i++){
							x.style.display = "";
						}

						var anchor = thisElement.getElementsByTagName('a');
						for(var i = 0; i &lt; anchor.length; i++){
							if(anchor[i].name.indexOf(hash) &gt;= 0){
								anchor[i].scrollIntoView(true);
								break;
							}
						}
					}

					// This function will jump to a table and display all rows of a given class name in different section.
					function showTableRows(hash, classname, event, messageAreaOfRestore){
						
						messageAreaOfRestore = typeof messageAreaOfRestore !== 'undefined' ? messageAreaOfRestore : 0;
						if(event.preventDefault) {
							event.preventDefault();
						}else {
							event.returnValue = false;
						}
						var index = 0;
						var thisElement = event.target || event.srcElement;
						var type = thisElement.getAttribute('type');
						
						while(thisElement){
							if(thisElement.className &amp;&amp; !(thisElement.className.indexOf('section_container') &lt; 0)){
								break;
							}
							
							if(thisElement.tagName.indexOf('TR') &gt;= 0 &amp;&amp; typeof type == 'undefined'){
								var table = document.getElementById('overview_table');
								var rows = table.rows;
								for(var i = 0; i &lt; rows.length; i++){
									if(rows[i] == thisElement){
										break;
									} else if(getElementsByClassName(rows[i], 'category_title').length &gt; 0){
										index++;
									}
								}
								//console.log("Row: " + thisElement.rowIndex);
								//index = Math.floor(thisElement.rowIndex / 4);
							}else if(thisElement.tagName.indexOf('TR') &gt;= 0 &amp;&amp; typeof type != 'undefined'){
								var table = document.getElementById('restore_nested_requests');
								var rows = table.rows;
								for(var i = 0; i &lt; rows.length; i++){
									if(rows[i] == thisElement){
										//index += messageAreaOfRestore - 1;
										break;
									} else{
										index++;
									}
								}
							}
							
							thisElement = thisElement.parentNode;
						}
						var oldElement = thisElement;
						thisElement = thisElement.nextSibling;
						
						if(thisElement){
							while(thisElement){
								if(thisElement.className &amp;&amp; !(thisElement.className.indexOf('summary_container_class') &lt; 0)){
									if(index == 0){
										break;
									}else{
										index--;
									}
								}else if(thisElement.className &amp;&amp; !(thisElement.className.indexOf('section_header') &lt; 0) &amp;&amp; thisElement.getAttribute('anchor-name').indexOf('procsum') &gt;= 0){
									if(index == 0){
										oldElement = thisElement;
									}
								}
								thisElement = thisElement.nextSibling;
							}
						}
						// have to check if the process message panel is open
						var test = thisElement.style.display;
						if(test != "")
						{
							var funcName = oldElement.onclick;
							if(document.createEvent){
								var evt = document.createEvent("MouseEvents");
								evt.initEvent("click", false, false);
								oldElement.dispatchEvent(evt);
							}else if(document.createEventObject){
								var evt = document.createEventObject("MouseEvents");
								//evt.initEvent("click", false, false);
								oldElement.fireEvent('onclick', evt);
							}
						}
					
						var rows = getElementsByClassName(thisElement, classname);

						for(var i = 0, x; x=rows[i]; i++){
							x.style.display = "";
						}

						// find anchor from the inside of this element
						var anchor = thisElement.getElementsByTagName('a');
						for(var i = 0; i &lt; anchor.length; i++){
							if(anchor[i].name.indexOf(hash) &gt;= 0){
								anchor[i].scrollIntoView(true);
								break;
							}
						}
						//thisElement.scrollIntoView(true);
					}
					
					// Toggle the direction of the arrow
					function switchArrow(direction)
					{
						if(direction == "c") {
							return "data:image/gif;base64,R0lGODlhCQAFAIAAAP///wAAACH5BAEHAAAALAAAAAAJAAUAAAIKjH+ACYoNGWxhFgA7";
						}
						else
						{
							return "data:image/gif;base64,R0lGODlhBQAJAIAAAP///3l5eSH5BAEHAAAALAAAAAAFAAkAAAIMDA5hp9v2YlJsJQQKADs=";
						}
					}
					
					// This function is used to swap the arrow's id
					function swap(id, blockId, event){
						preventEvent(event);

						if(document.getElementById(blockId).style.display == "none") {
							document.getElementById(id).src = switchArrow("e");
						}
						else{
							var node = document.getElementById(id);
							node.src = switchArrow("c");
						}

						return true;
					}
					
					function SwapChildrenElement(arrowclass, parentclass, blockclass, followclass, event){
						preventEvent(event);
						var thisElement = event.target || event.srcElement;
						
						while(thisElement){
							if(thisElement.className &amp;&amp; thisElement.className.indexOf('entity_details') &gt;= 0){
								break;
							}
							
							thisElement = thisElement.parentNode;
						}
						var parentElement = thisElement;
						if(parentElement){
							var followElements = getElementsByClassName(parentElement, followclass);
							var blockElements = getElementsByClassName(parentElement, blockclass);
						
							var toExpand = true;
							for(var i = 0; i &lt; followElements.length; i++){
								var element = followElements[i];
								if(element.style.display == "none"){
									toExpand = false;
									break;
								}
							}
						
							if(!toExpand){
								for(var i = 0; i &lt; blockElements.length; i++){
									var element = blockElements[i];
									element.style.display = "none";
								}
								
								//swap arrow
								for(var i = 0; i &lt; followElements.length; i++){
									var element = followElements[i];
									var imgNode = getElementsByClassName(element, arrowclass);
									for(var j = 0, x; x=imgNode[j]; j++){
										x.src = switchArrow("e");
									}
								}
							}
						}
					}
					
					// swap arrow
					// arrowclass: class name of arrow
					// blockclass: class name of container that arrow follows
					function SwapByClass(arrowclass, blockclass, event){
						preventEvent(event);
						
						// get the node that triggers the event
						var thisElement = event.target || event.srcElement;
						
						// search for the parent node that contains "swaparrow" attribute
						while(thisElement){
							if(thisElement.getAttribute("swaparrow")){
								if( thisElement.getAttribute("swaparrow") == "true"){
									break;
								}else{
									thisElement = thisElement.parentNode;
								}
							}else{
								thisElement = thisElement.parentNode;
							}
						}
						
						// if found
						if(thisElement){
							var imgNode = getElementsByClassName(thisElement, arrowclass);
							var hiddenNode = thisElement;
							while(hiddenNode){
								if(hiddenNode.className){
									if(!(hiddenNode.className.indexOf(blockclass) &lt; 0)){
										break;
									}
								}
								
								hiddenNode = hiddenNode.nextSibling;
							}
							
							if(hiddenNode.style.display == "none"){
								for(var i = 0, x; x=imgNode[i]; i++){
									x.src = switchArrow("e");
								}
							}else{
								for(var i = 0, x; x=imgNode[i]; i++){
									x.src = switchArrow("c");
								}
							}
							
							// enable Garbage Collection
							imgNode = null;
							hiddenNode = null;
						}
						
						// clean
						thisElement = null;
						event = null;
					}
					
					function addResizeEvent(contaienrClassName, classname){
						var sections = getElementsByClassName(document, contaienrClassName);
						if(sections.length &gt; 0){
							var container = sections[0].previousSibling;
							while(container){
								if(container.nodeName){
									if(container.nodeName.toLowerCase() == "div"){
										break;
									}
								}
								
								container = container.previousSibling;
							}
							
							if(container){
								var onclickString = container.getAttribute("onclick");
								onclickString = onclickString + "resizeBlocks('"+classname+"');";
								container.setAttribute("onclick", onclickString);
							}
						}
					}
					
					function expandAfterAnchor(event){
						// expand detail section
						var detailSection = document.getElementById('details_container');
						var detailSectionHeaderArrow = document.getElementById('details_container_arrow');
						if(detailSection){
							detailSection.style.display="";
						}
						if(detailSectionHeaderArrow){
							detailSectionHeaderArrow.src = switchArrow('c');
						}
						// get the node that triggers the event
						var thisElement = event.target || event.srcElement;
						var hash = thisElement.href;
						if(hash){
							hash = hash.substring(hash.indexOf('#') + 1);
							hash = decodeURI(hash);
							//console.log("hash: " + hash);
							var elem = getElementsByAttribute(document, 'name');
							for(var i = 0; i &lt; elem.length; i++){
								//console.log("elem[i]: " + elem[i] + " name: " + elem[i].getAttribute('name') + " index: " + elem[i].getAttribute('name').indexOf(hash));
								var name = elem[i].getAttribute('name');
								if(!(name.indexOf(hash) &lt; 0)){
									thisElement = elem[i];
									break;
								}
							}
							
							while(thisElement){
								//console.log(thisElement);
								if(thisElement.className &amp;&amp; thisElement.className.indexOf('security_headers') &gt;= 0){
									//console.log("this element: " + thisElement.className);
									break;
								}
								thisElement = thisElement.nextSibling;
							}
							var eventElement = getElementsByClassName(thisElement, 'blockArrow');
							for(var i = 0; i &lt; eventElement.length; i++){
								eventElement[i].src = switchArrow('c');
							}
							
							while(thisElement){
								//console.log(thisElement + ": " + thisElement.className);
								if(thisElement.className &amp;&amp; thisElement.className.indexOf('statistic_table_content_block') &gt;= 0){
									break;
								}
								thisElement = thisElement.nextSibling;
							}
							//console.log("finally:" + thisElement);
							thisElement.style.display = "";
						}
					}
					
					function resizeBlocks(classname){
						var blocks = getElementsByClassName(document, classname);
						
						if(blocks.length &gt; 0){
							var max = 0;
		
							for(var i = 0, x; x=blocks[i]; i++){
								if(x.offsetWidth > max){
									max = x.offsetWidth ;
								}
							}
		
							for(var i = 0, x; x=blocks[i]; i++){
								x.width = max;
							}
						}
					}

					// This function resizes all tables with class name
					// To make certain tables line up, simply give them a class and add it here
					function resizeAllTables() {
					//resizeTables('archive_process_details');
					//resizeTables('insert_process_details');
					//resizeTables('statistic_headers');
					//resizeTables('entity_headers');
					//resizeTables('table_access_headers');
					//resizeTables('entity_details');
					//resizeTables('extended_objects');
					//resizeTables('impact_analysis');
					resizeTables('message_box');
					resizeTables('user_security_headers');
					resizeTables('object_security_headers');
					resizeTables('directory_headers');
					resizeTables('function_security_headers');
					//resizeTables('maskingpolicy_table');
					addResizeEvent("statistic_container_class", "archive_statistic_header_name");
					addResizeEvent("section_container relation_container_class", "relation_header_name");
					}

					// Resize All Tables On Load
					window.onload = onLoad;

					// This function will determine the sizes of the tables on load and set them
					// appropriately. It will also add CSS classes to the banners to make them clickable.
					function onLoad(){
					resizeAllTables();
					resizeBlocks("scroll_table");
					//setRowWidth("scroll_table");
					// format all date
					dateFormat();

					// format long names
					longNamePopup();

					// float board for messages
					//messageCatalogBoard();

					// get the width of page
					{
					var width = document.body.offsetWidth;
					if(width &gt; 980){
								var nodes = getElementsByClassName(document, "resizeWindow");
							
								for(var i = 0, x; x=nodes[i]; i++){
									if(x.className.indexOf("report_content") &gt;= 0){
										x.style.width = (width-30) + "px";
									}else{
										x.style.width = width + "px";
									}
								}
							}
						}
					}
					
					function dateFormat(){
						// get all date
						var dates = getElementsByClassName(document, "date");
						
						for(var i = 0; i &lt; dates.length; i++){
							var date = dates[i].textContent || dates[i].innerText;
							
							var spaceIndex = date.indexOf(' ');
							
							var dateTime = date.substring(0, spaceIndex);
							var y = dateTime.split("-");
							var newDate = new Date(y[0], y[1]-1, y[2]);
							var currentDate = new Date();
							
							if(currentDate.getFullYear() === newDate.getFullYear()){
								if(currentDate.getMonth() === newDate.getMonth()){
									if(currentDate.getDate() === newDate.getDate()){
										var strDate = "Today" + date.substring(spaceIndex);
										dates[i].textContent = strDate;
										dates[i].innerText = strDate;
									}else if((currentDate.getDate() - newDate.getDate()) === 1){
										var strDate = "Yesterday" + date.substring(spaceIndex);
										dates[i].textContent = strDate;
										dates[i].innerText = strDate;
									}
								}
							}
						}
					}
					
					// This function determines the max cell width in tables with the same class name
					// It then will set the width based on the max cell size for all rows
					function resizeTables(className) {	
					    // Get all tables with a given class name
					    var tables = getElementsByClassName(document.body, className);
					    
					    // Create storage for cell widths
					    var cellWidths = new Array();
					
						// First determine the max cell width for each column
					    for(var i = 0; i &lt; tables.length; i++)
					    {
					        for(var j = 0; j &lt; tables[i].rows[0].cells.length; j++)
					        {
					           var cell = tables[i].rows[0].cells[j];
					           if(!cellWidths[j] || cellWidths[j] &lt; cell.clientWidth)
					                cellWidths[j] = cell.clientWidth;
					        }
					    }
					
						// Set the table cell width for each column to the max cell width for that column
					    for(var i = 0; i &lt; tables.length; i++)
					    {
					        for(var j = 0; j &lt; tables[i].rows[0].cells.length; j++)
							{
								tables[i].rows[0].cells[j].style.width = cellWidths[j]+'px';
							}
						}
					}

					// expand/collapse all elements in one block
					function toggleAll(action, event){
						if(event.preventDefault) {
							event.preventDefault();
						}
						else {
							event.returnValue = false;
						}
						var thisElement = event.target || event.srcElement;
						var className = thisElement.className
						while(className.indexOf("section_header drop_down_hover") &lt; 0){
							className = thisElement.parentNode.className;
							thisElement = thisElement.parentNode;
							if(!thisElement){
								break;
							}
						}
						if(thisElement){
							var blockElem = thisElement.nextSibling;
							while(blockElem){
								if(!blockElem){
									break;
								}
								if(blockElem.className){
									if(blockElem.className.indexOf("section_container ") &lt; 0){
										blockElem = blockElem.nextSibling;
									}else{
										break;
									}
								}else{
									blockElem = blockElem.nextSibling;
								}
							}
							if(blockElem){
								checkElem(thisElement, action);
								checkElem(blockElem, action);

								// if the contain block is closed, open it
								// set window location to this bar
								if(action == 'e'){
									blockElem.style.display = "";
									// move the bar to the top if possible
									var anchor = thisElement.getAttribute("anchor-name");
									while(thisElement &amp;&amp; anchor){
										if(thisElement.tagName &amp;&amp; thisElement.getAttribute('name')){
											if(thisElement.tagName.toLowerCase() =='a'&amp;&amp; thisElement.getAttribute('name').toLowerCase() == anchor){
												//alert("got it: " + thisElement.outerHTML);
												window.scroll(0, thisElement.offsetTop);
												break;
											}
											thisElement = thisElement.previousSibling;
										}else{
											thisElement = thisElement.previousSibling;
										}
									}
								}else{
								}
							}
						}
						
						
						// clean
						thisElement = null;
						className = null;
						blockElem = null;
					}
					
					// function for expand all / collapse all
					function toggleAllSections(action, event){
					
						if(event.preventDefault) {
							event.preventDefault();
						}
						else {
							event.returnValue = false;
						}
						
						var thisElement = event.target || event.srcElement;
						
						// search to the top of current report
						while(thisElement){
							if(thisElement.tagName){
								if(!(thisElement.tagName.toLowerCase().indexOf("body")&lt;0)){
									break;
								}
							}
							
							if(thisElement.getAttribute("isinnerreport")){
								if(thisElement.getAttribute("isinnerreport").toLowerCase() == "true"){
									break;
								}
							}else{
								
							}
							
							thisElement = thisElement.parentNode;
						}
						
						// expand/collapse all parts
						if(thisElement){
							checkElem(thisElement, action);
						}
						
						// jump to currect position
						if(thisElement.tagName.toLowerCase() == "body"){
							jumpToTop();
						}else{
							window.location.href = "#" + thisElement.getAttribute("id");
						}
						
						// clean
						thisElement = null
					}

					function checkElem(element, action){
						var nodes = element.getElementsByTagName('*');
						if(element.getAttribute("inAllAction")){
							if(element.getAttribute("inAllAction") == "true"){
								if(action == 'e'){
									element.style.display = "";
								}else{
									element.style.display="none";
								}
							}	
						}
							
						if(element.getAttribute("inSwapAction")){
							if(element.getAttribute("inSwapAction") == "true"){
								if(action == 'c'){
									element.src = switchArrow('e');
								}else{
									element.src = switchArrow('c');
								}
							}	
						}
						
						for(var i = 0, x; x = nodes[i]; i++){
							if(x.getAttribute("inAllAction")){
								if(x.getAttribute("inAllAction") == "true"){
									if(action == 'e'){
										x.style.display = "";
									}else{
										x.style.display="none";
									}
								}	
							}
							
							if(x.getAttribute("inSwapAction")){
								if(x.getAttribute("inSwapAction") == "true"){
									if(action == 'c'){
										x.src = switchArrow('e');
									}else{
										x.src = switchArrow('c');
									}
								}	
							}
						}
						
						// clean
						nodes = null;
					}
					window.onscroll = jumpToTop;
					// jumpt to top of each block
					function jumpToTop(){
						var windowSize = window.innerHeight || document.documentElement.clientHeight;
						var offsetTop = document.getElementById('back_to_top_block').offsetTop;
						var top = document.documentElement.scrollTop || document.body.scrollTop;
						
						var node = document.getElementById('back_to_top_block');
						if(top &gt; 0){
							node.style.display = "block";
							node.style.top = windowSize - 100 + 'px';
						}else{
							node.style.display = "none";
							node.style.top = 0;
						}
					}
					
					function topAction(containerId, anchor){
						//alert("test");
						if(document.getElementById(containerId).style.display="none"){
							window.location.href = "#" + anchor;
						}
					}
					
					function jumpTopAnchor(anchor, event){
						// get current element
						var thisElement = event.target || event.srcElement;
						
						while(true){
							thisElement = thisElement.parentNode;
							if(!thisElement){
								break;
							}
							if(thisElement.tagName.toLowerCase() == "body" || thisElement.getAttribute('isinnerreport') == "true"){
								break;
							}
						}
						
						if(thisElement){
							var nodes = thisElement.getElementsByTagName("*");
						
							for(var i = 0, x; i &lt; nodes.length; i++){
								if(nodes[i].getAttribute('isInnerReport') != true){
									if(nodes[i].getAttribute('name')){
										if(nodes[i].getAttribute('name') == anchor){
											nodes[i].scrollIntoView(true); 
											break;
										}
									}
								}
							}
						}
					}
				</script>
				<!-- END Javascript functions to add utility to the report -->

		</head>
	</xsl:template>
</xsl:stylesheet>